if (select(2, UnitClass("player"))) ~= "ROGUE" then return end
----------------------
TickTo = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0")
local addon = TickTo
local font = GameFontNormal:GetFont()
----------------------
local energyvalues = {
	60,
	40,
	35,
	25,
}

function addon:OnInitialize()

	self:RegisterDB("TTDB", "TTPerCharDB")

end

function addon:OnEnable()

self:RegisterBucketEvent("UNIT_ENERGY", 0.2, "EnergyUpdate")
self:CreateFrame()
self:EnergyUpdate()
self:RestorePosition()

end

function addon:CreateFrame()

	if self.frame then
		return
	end

local f = CreateFrame("Frame", "TickToFrame", UIParent)
self.frame = f

f:Show()
f:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
f:SetWidth(40)
f:SetHeight(50)
f:EnableMouse(true)
f:SetMovable(true)
f:RegisterForDrag"LeftButton"
f:SetScript("OnDragStart", function() if not InCombatLockdown() and IsAltKeyDown() then this:StartMoving() end end)
f:SetScript("OnDragStop", function() if not InCombatLockdown() then this:StopMovingOrSizing() self:SavePosition() end end)

f:SetBackdropColor(0, 0, 0)
f:SetBackdropBorderColor(0, 0, 0)
f:SetPoint("CENTER", UIParent)

for k, v in ipairs( energyvalues ) do

	local offset = 8 - (k * 10)
	
		local ff = f:CreateFontString(nil,"OVERLAY")
		f[v] = ff
		ff:SetFont(font, 11)
		ff:SetWidth(27)
		ff:SetHeight(15)
		ff:SetText("")
		ff:SetJustifyH("CENTER")
		ff:ClearAllPoints()
		ff:SetPoint("TOP", f, "TOP", 0, offset )
		
end


end

function addon:EnergyUpdate()

	for k, v in ipairs( energyvalues ) do
		self:UpdateTicks(v)
	end

end

function addon:UpdateTicks(v)

local numticks
local amount = UnitMana("player")

	numticks = ceil( (v - amount) / 20 )
	
	       	if UnitIsDeadOrGhost("player") then 
			numticks = "|cffffffff"..v..":|r |cffff00000|r"
		elseif numticks <= 0 then
			numticks = "|cffffffff"..v..":|r |cff00ff000|r"
		elseif numticks == 1 then
			numticks = "|cffffffff"..v..":|r |cffff66001|r"
		else
			numticks = "|cffffffff"..v..":|r |cffff00002|r"
		end
		
self.frame[v]:SetText(numticks)

end

function addon:SavePosition()

	local f = self.frame

	self.db.profile.posx = f:GetLeft()
	self.db.profile.posy = f:GetTop()

end

function addon:RestorePosition()

    local f = self.frame
	local x = self.db.profile.posx
	local y = self.db.profile.posy

	if not x or not y then return end

	f:ClearAllPoints()
	f:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", x, y)

end